#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two5004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two5004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two5004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 500
# -------------------------------------------------------------------------------------------------
shot2two5004xi = {
        1:'0x0y-499z',
        2:'100x-213y-440z',
        3:'109x-203y-443z',
        4:'111x-284y-395z',
        5:'118x-193y-445z',
        6:'120x-483y-35z',
        7:'124x-274y-398z',
        8:'125x-183y-447z',
        9:'132x-173y-449z',
        10:'136x-264y-401z',
        11:'138x-162y-452z',
        12:'138x-4y-480z',
        13:'143x-11y-478z',
        14:'143x-152y-454z',
        15:'145x-476y-40z',
        16:'147x-141y-456z',
        17:'147x-19y-477z',
        18:'148x-253y-404z',
        19:'150x-28y-475z',
        20:'151x-130y-458z',
        21:'153x-37y-474z',
        22:'154x-119y-460z',
        23:'155x-46y-472z',
        24:'156x-108y-462z',
        25:'157x-56y-471z',
        26:'158x-66y-469z',
        27:'158x-97y-464z',
        28:'159x-242y-407z',
        29:'159x-76y-467z',
        30:'159x-87y-465z',
        31:'169x-230y-410z',
        32:'170x-467y-45z',
        33:'178x-217y-413z',
        34:'17x-499y-15z',
        35:'186x-205y-416z',
        36:'194x-192y-418z',
        37:'194x-457y-50z',
        38:'19x-211y-452z',
        39:'19x-328y-376z',
        40:'1x-332y-373z',
        41:'200x-178y-421z',
        42:'206x-165y-424z',
        43:'20x-265y-423z',
        44:'211x-151y-426z',
        45:'211x-9y-452z',
        46:'215x-138y-429z',
        47:'215x-21y-450z',
        48:'218x-124y-431z',
        49:'218x-33y-448z',
        50:'218x-446y-55z',
        51:'220x-45y-446z',
        52:'221x-111y-434z',
        53:'222x-58y-443z',
        54:'222x-97y-436z',
        55:'223x-71y-441z',
        56:'223x-84y-439z',
        57:'234x-441y0z',
        58:'240x-433y-60z',
        59:'257x-428y-4z',
        60:'262x-420y-65z',
        61:'279x-414y-9z',
        62:'284x-405y-70z',
        63:'300x-399y-14z',
        64:'304x-389y-75z',
        65:'30x-206y-454z',
        66:'321x-382y-19z',
        67:'323x-372y-80z',
        68:'33x-259y-425z',
        69:'340x-365y-24z',
        70:'342x-354y-85z',
        71:'359x-335y-90z',
        72:'359x-346y-29z',
        73:'35x-323y-379z',
        74:'376x-315y-94z',
        75:'376x-327y-34z',
        76:'391x-294y-99z',
        77:'392x-306y-39z',
        78:'405x-273y-104z',
        79:'407x-285y-44z',
        80:'40x-199y-456z',
        81:'418x-251y-109z',
        82:'421x-263y-49z',
        83:'429x-228y-114z',
        84:'434x-240y-54z',
        85:'43x-497y-20z',
        86:'440x-204y-119z',
        87:'446x-217y-59z',
        88:'449x-181y-124z',
        89:'456x-157y-129z',
        90:'456x-193y-64z',
        91:'463x-132y-133z',
        92:'465x-169y-69z',
        93:'468x-107y-138z',
        94:'46x-253y-428z',
        95:'471x-82y-143z',
        96:'472x-144y-74z',
        97:'473x-57y-148z',
        98:'474x-32y-153z',
        99:'474x-8y-157z',
        100:'478x-119y-79z',
        101:'482x-129y-1z',
        102:'483x-94y-84z',
        103:'487x-68y-89z',
        104:'489x-103y-6z',
        105:'489x-17y-99z',
        106:'489x-42y-94z',
        107:'493x-78y-11z',
        108:'496x-52y-16z',
        109:'498x-26y-21z',
        110:'49x-192y-458z',
        111:'52x-317y-383z',
        112:'58x-246y-431z',
        113:'67x-310y-386z',
        114:'69x-222y-552z',
        115:'69x-494y-25z',
        116:'6x-270y-420z',
        117:'70x-238y-433z',
        118:'81x-230y-436z',
        119:'82x-302y-389z',
        120:'91x-222y-438z',
        121:'95x-489y-30z',
        122:'97x-293y-392z',
        123:'9x-217y-450z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire500two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire500two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two5004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two5004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two5004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        